/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2005 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// Rootfly.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Rootfly.h"
#include "RootflyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRootflyApp

BEGIN_MESSAGE_MAP(CRootflyApp, CWinApp)
   //{{AFX_MSG_MAP(CRootflyApp)
      // NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRootflyApp construction

//empty constructor
CRootflyApp::CRootflyApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRootflyApp object

CRootflyApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CRootflyApp initialization

BOOL CRootflyApp::InitInstance()
{

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

  // load accelerator for keyboard shortcuts
  m_haccel = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR1));

  CRootflyDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

BOOL CRootflyApp::ProcessMessageFilter(int code, LPMSG lpMsg) 
{
  if(m_haccel)
  {
    // translate keyboard shortcuts using accelerator
    if (::TranslateAccelerator(m_pMainWnd->m_hWnd, m_haccel, lpMsg)) 
      return(TRUE);
  }

	return CWinApp::ProcessMessageFilter(code, lpMsg);
}
