
#ifndef SESSION_ARRAY_HEADER
#define SESSION_ARRAY_HEADER

//#include "stdafx.h"
#include <string>
#include <vector>
using std::string;

struct Date
{
  int year, month, day;
  Date() : year(-1), month(-1), day(-1) {}

  operator<(const Date& other) const
  {
    return (year < other.year
            || (year == other.year
                && (month < other.month
                    || month == other.month && day < other.day)));
  }

  operator>(const Date& other) const
  {
    return (year > other.year
            || (year == other.year
                && (month > other.month
                    || month == other.month && day > other.day)));
  }

  operator==(const Date& other) const
  {
    return (year == other.year && month == other.month && day == other.day);
  }

  void operator++()  // prefix increment ++p
  {

    int month_length[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 30, 31, 31};

    if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0)))  
    { month_length[1]++;  /* leap year */ }
//    for (int i = 0 ; i < month ; i++)  day += month_length[i];

    day++;

    if(day > month_length[month])
    {
      day = day - month_length[month];
      month++;
      if(month > 12)
      {
        year++;
        month = 1;
      }
    }
  }
  void operator++(int)  // postfix increment p++
  {
    ++(*this);
  }
};

// ------------------------------------------------------------------------------------------------

class Session_Array{

public:
	Session_Array();

//	int add_session(string inSession);
//	int find_session(string inSession);
//  string get_session(int index);
//	int get_year(int index);
//  int get_month(int index);
//  int get_day(int index);
	int add_date(const Date& date);
	Date GetDate(int sessionNumber);

private:

//    string *sessions; // full of session dates
//	int     *flags;
//	int pointer;      // points to one after last entry in array
//	int maxTableSize; // current max size sessions can be
	std::vector<Date> dates;
	int CheckForDate(const Date& date);
	void SortArray();
  int GetDayOfYear(int month, int day, int year);

};

#endif